/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't deletee this Copyright/Copyleft inscription in this source file.
 *
 * @author www.vishia.de
 * @version 0.81d
 * list of changes:
 * 2007-03-01: JcHartmut www.vishia.org creation from older source
 *
 ****************************************************************************/

#include "ComparatorJc.h"
#include "ExceptionJc.h"
/*@CLASS_C Arrays @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

//int binarySearch_int_ArraysJc(


/*@CLASS_C Collections @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

/** Static method to search an object in a sorted list. See java.util.Arrays.binarySearch
 */

/**binary search in any struct. A class containing the comparator should be known.
 * @param a An array of Objects of the expected type.
 * @param key A object of the expected type.
 * @param c The comparator to compare the elements of a with the element key.
 *          The types in a and key have to be matched to the Comparator. In original java
 *          a class cast exception is thrown if it is not matched.
 */
int binarySearch_Object_ArraysJc(const void* a, const void* key, ComparatorJcREF c) ; //ComparatorJcRefp c);

/**
 * @param stacktraceThreadContext This argument is expected, because a minimal calulation time is required.
 */
int binarySearch_int_ii_ArraysJc(int32ARRAY const* a, int fromIndex, int toIndex, int32 key, StacktraceThreadContext_s* stacktraceThreadContext);


/**internal routine to search, see java.util.Arrays.
 */
int binarySearch0_int_ii_ArraysJc(int32ARRAY const* a, int fromIndex, int toIndex, int32 key);

