/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't deletee this Copyright/Copyleft inscription in this source file.
 *
 * @content Definition of a logging interface.
 *
 * @author Jchartmut www.vishia.org
 * @version 0.82
 * list of changes:
 * 2006-05-00: www.vishia.de creation
 *
 ****************************************************************************/
#ifndef __LogMessageJc_h__
#define __LogMessageJc_h__


#include "ExceptionJc.h"




/**Sends a message to a log system.
 * @param identNumber The identnumber idents the source and kind of message.
                      It is possible to select the destination of message output by ident numbers.
                      It is also possible to select output texts in foreign languages on output system by ident number.
                      It is possible to mark "comming" and "going" from a message, using the positiv and negativ value of the number.
                      The positiv and negativ value should present the same identNumber.
 * @param text The default, immediate output text
 */
void sendMsg_LogMessageJc(struct LogMessageJc_t* ythis, int identNumber, const char* text, StacktraceThreadContext_s* _threadContext);



/**Sends a message to a log system.
 * @param identNumber The identnumber idents the source and kind of message.
                      It is possible to select the destination of message output by ident numbers.
                      It is also possible to select output texts in foreign languages on output system by ident number.
                      It is possible to mark "comming" and "going" from a message, using the positiv and negativ value of the number.
                      The positiv and negativ value should present the same identNumber.
 * @param text The default, immediate output text
 * @param val1 an integer value to place in text or store
 * @param val2 an integer value to place in text or store
 * @param val3 an integer value to place in text or store
 * @param val4 an integer value to place in text or store
 */
void sendMsg_4i_LogMessageJc(struct LogMessageJc_t* ythis, int identNumber, const char* text, int val1, int val2, int val3, int val4, StacktraceThreadContext_s* _threadContext);





#endif /*__LogMessageJc_h__*/
