/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * @content: This file is only used til the struct Thread_s is not established.
 *
 * @author JcHartmut www.vishia.org
 * @version 0.81
 * list of changes:
 * 2006-05-00: www.vishia.de creation
 *
 ****************************************************************************/

#include "os_wrapper.h"
#include "ExceptionJc.h"
#include "StringJc.h"

/**An instance of this struct is created in any thread if the currentThreadContext is getted.
 */
typedef struct ThreadContext_t
{ /**The Requirements of stacktrc respectively ThreadContext. */
  StacktraceThreadContext_s stacktraceThreadContext;
  StringBufferJc defaultStringBuffer;
  char defaultStringBuffer_addChars_[250];
  StacktraceElementJcARRAY stackTraceEntries;
  StacktraceElementJc moreEntries[100 - STATICSIZE_StacktraceElementJcARRAY];
}ThreadContext_s;


static bool bInitThreadContextSettings = false;

void threadContextInit(MemC threadContextRaw)
{ if(size_MemC(threadContextRaw) != sizeof(ThreadContext_s))
  { //this is a fatal error because confuse software, it must be matched!
    throw_s0Jc(ident_RuntimeExceptionJc, "threadcontext initialization problem", size_MemC(threadContextRaw), null, 0);
    //systemCrashError("");
  }
  init0_MemC(threadContextRaw);
  { ThreadContext_s* context = (ThreadContext_s*)threadContextRaw.address;
    ctor_s0i_StringBufferJc(&context->defaultStringBuffer, context->defaultStringBuffer_addChars_, sizeof(context->defaultStringBuffer_addChars_));
    context->stacktraceThreadContext.excMsg = &context->defaultStringBuffer;
    ctor_ObjectArrayJc(&context->stackTraceEntries.head, 100, sizeof(StacktraceElementJc), null, 0);
    context->stacktraceThreadContext.stacktraceBuffer = &context->stackTraceEntries;
  }
}




/**This method implements the forward declaration in ExceptionJc.h for this the Thread concept. */
StacktraceThreadContext_s* getCurrent_StacktraceThreadContext()
{ if(!bInitThreadContextSettings)
  { os_setThreadContextSettings(threadContextInit, sizeof(ThreadContext_s));
    bInitThreadContextSettings = true;
  }
  { MemC threadContextRaw = os_getCurrentThreadContext();
    ThreadContext_s* threadContext = (ThreadContext_s*)threadContextRaw.address;
    return &(threadContext->stacktraceThreadContext);
  }
}



