/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * @content This file contains the implementation of os_wrapper for MS-Windows.
 * @author JcHartmut www.vishia.org
 * @version 0.81ad
 * list of changes:
 * 2007-10-01: JcHartmut creation
 *
 ****************************************************************************/
#include "os_wrapper.h"

#include "ObjectJc.h"
#include "ArraysJc.h"
#undef boolean
#include <string.h>
#include <wtypes.h>
#include <winbase.h>

typedef struct AllThreadContext_Jc_t
{ /**Based on Object_Jc because Reflections are private encapsulated.*/
  ObjectJc object;
  /**Actual nr of Threads with ThreadContext. */
  int32 nrofThreads;

  /**ObjectArray with elements of type int32. The number of elements ist constant defined with staticSize_int32ARRAY. */
  int32ARRAY id;
  /**Rest of the id-array.*/
  int32 idAdd[1000];
  MemAreaC* context[1000];

}AllThreadContext_Jc;


/**The static singleton AllTheadContext_Jc instance, with initialization.
 */
AllThreadContext_Jc allThreads_Rtos
= {0};
#if 0
{ CONST_Object_Jc(sizeof(AllThreadContext_Jc), &allThreads_Rtos, null/*REFLECTION_AllThreadContext_Jc*/)
, 0
, CONSTaddSize_int32ARRAY(&allThreads_Rtos.id, 1000)
, {0}
, {null}
};
#endif


static OS_ThreadContextInitRoutine* initRoutine_g = null;
static int sizeofThreadContext_g = 0;

void os_setThreadContextSettings(OS_ThreadContextInitRoutine* initRoutineP, int sizeofThreadContextP)
{ initRoutine_g = initRoutineP;
  sizeofThreadContext_g = sizeofThreadContextP;
}


/*The implementiation uses binary search to assign the idThread to the threadContext. */
MemC os_getCurrentThreadContextFromId(int idThread)
{ MemC current;
  int idxContext;
  idxContext = binarySearch0_int_ii_ArraysJc(&allThreads_Rtos.id, 0, allThreads_Rtos.nrofThreads, idThread);
  if(idxContext >=0)
  { current.address = allThreads_Rtos.context[idxContext];
    setSizeAndOffset_MemC(current, sizeofThreadContext_g, 0);
  }
  else if(idxContext < 0 && allThreads_Rtos.nrofThreads < ARRAYLEN(allThreads_Rtos.context))
  { //the thread id is not found in the table, that is because the thread is created and started outside this routines.
    //In this case a Thread_Jc structure is to be created.
    current = alloc_MemC(sizeofThreadContext_g);
    initRoutine_g(current);
    //arrange the new Thread in the list.
    idxContext = -idxContext -1; //the index at set position.
    //shift all ids to back
    memmove(&allThreads_Rtos.id.data[idxContext +1], &allThreads_Rtos.id.data[idxContext], sizeof(allThreads_Rtos.id.data[0])* (allThreads_Rtos.nrofThreads - idxContext));
    allThreads_Rtos.id.data[idxContext] = idThread;
    //shift all pointers to back.
    memmove(&allThreads_Rtos.context[idxContext +1], &allThreads_Rtos.context[idxContext], sizeof(allThreads_Rtos.context[0])* (allThreads_Rtos.nrofThreads - idxContext));
    //
    allThreads_Rtos.nrofThreads +=1;
    allThreads_Rtos.context[idxContext] = current.address;
    //
  }
  else if(idxContext <0)
  { //Exception
    current.address = null;
  }
  return current;
}



MemC os_getCurrentThreadContext()
{ //int idThread = GetCurrentThreadId();        //Windows-API
  int idThread = (int)(GetCurrentThreadId());   //Windows-API privides te HANDLE of the Thread.
  return os_getCurrentThreadContextFromId(idThread);
}



