/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * @content This file contains compiler- and os-dependent definitionsthe
 * for Visual-Studio-6 on MS-Windows.
 *
 * @author JcHartmut www.vishia.org
 * @version 0.81  (year-month-day)
 * list of changes:
 * 2007-10-01: JcHartmut creation
 *
 ****************************************************************************/
#ifndef complctr_h_
#define complctr_h_


//Zielplattform
//-------------
/** Folgender Schalter ist gesetzt zur Auswahl der Betriebssystemplattform Windows ist. Damit knnen Betriebssystemzugriffe bedingt compiliert werden.*/
#define __OS_IS_WINDOWS__

/** Folgender Schalter ist gesetzt zur Auswahl des Compilers MSC6. Damit knnen spezifische Compilereigenschaften mittels bedingter Compilierung bercksichtigt werden.*/
#define __COMPILER_IS_MSC6__

/** Folgender Schalter ist gesetzt zur Auswahl der C++-Compilierung. In einigen Quellen kann es einen Unterschied geben, wenn eine C-Abbildung der Quellen
    bercksichtigt werden muss. Das standardgem definierte Makro __cplusplus ist nicht immer fr dieses Zweck verwendbar, da auch der Einsatz der C++-Compilierung
    fr eine C-Abbildung erfolgen kann. Wenn die Gesamt-Source (beispielsweise ein Headerfile) gegebenenfalls auch als C-Abbildung
    compiliert werden muss, dann mssen alle Teile, die nur unter C++ lauffhig sind, mit diesem Schalter bedingt compiliert werden.
*/
#define __CPLUSGEN

#define MemUnit char            //sizeof(MemUnit) muss 1 sein!
#define BYTE_IN_memUnit 1       //im PC gilt: 1 MemUnit = 1 Byte

typedef unsigned char        uint8;
typedef unsigned short       uint16;
typedef unsigned long        uint32;

typedef signed char          int8;
typedef short                int16;
typedef long                 int32;
typedef double long          int64;

typedef float                float32;

//plattformunabhaengige Ergaenzungen
//folgende Typen sind besser schreib- und lesbar
typedef unsigned short int   ushort;
typedef unsigned long int    ulong;
typedef unsigned int         uint;

#undef null
#define null 0

#ifndef __cplusplus
  /**Define of the C++-keyword bool also in a C environment.
   * NOTE: You can undef it if any proprietary headers are in conflict with them.
   */
  #define bool int
#endif

/** Folgendes Define wird nach einer Struktur insbesondere fr GNU-Compiler verwendet. Es ist fr MSC6 leer,
    weil stattdessen ein pragma pack(1) verwendet werden muss.
*/
#define GNU_PACKED


/**Das Makro METHOD_C soll fr C++ regeln, dass eine Methode/Routine/Funktion nach den C-Konventionen definiert ist.
 * Fr eine reine C-Compilierung ist das Makro leer.
 */
#ifdef xxx__cplusplus
  #define METHOD_C extern "C"
#else
  #define METHOD_C
#endif




#endif  //complctr_h_
