/****************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * @content This file contains the implementation of os_wrapper for MS-Windows.
 * @author JcHartmut www.vishia.org
 * @version 0.81ad
 * list of changes:
 * 2007-10-01: JcHartmut creation
 *
 ****************************************************************************/
#include "complctr.h"
#include "os_wrapper.h"

#include <wtypes.h>
#include <winbase.h>


#define OS_DEFAULT_STACKSIZE 0x1000













int os_createThread(struct OS_HandleThread_t const** handle, OS_ThreadRoutine routine, void* data, const char* name, int prio, int stacksize)
{ int ok = 0;
  unsigned long threadId;

  if(stacksize <= 0)
  { stacksize = OS_DEFAULT_STACKSIZE;
  }
  if(prio <= 0 || prio > 255)
  { ok = -1;
  }
  if(ok == 0)
  {
    /*on thread creation the function pointer to the run routine is delivered.
     *This routine will be started in the created thread.
     */
    HANDLE hThread = CreateThread
    ( NULL
    , 2000
    , (LPTHREAD_START_ROUTINE)(routine)
    , data   //Pointer to data of the method of the thread, first parameter
    , 0               //flags
    , &threadId
    );
    { int nWindowsPrio = prio
                       * (THREAD_PRIORITY_HIGHEST - THREAD_PRIORITY_LOWEST) / (255 - 0)
                       + THREAD_PRIORITY_LOWEST;

      SetThreadPriority(hThread, nWindowsPrio);
    }

  }

  if(ok != 0)
  { //any RMOS error:
    //RmKillTask(RM_TASK_DELETE, taskID);
    *handle = null;
  }
  else
  { *handle = (struct OS_HandleThread_t*)threadId;
  }

  return ok;
}
