#ifndef __SetValueGenerator_h__
#define __SetValueGenerator_h__
//this file is generated by Java2C

#include "ObjectJc.h"

#include "ExceptionJc.h"

#include "allReferences.h"
typedef struct SetValueGenerator__Target_t
{ ObjectJc object;
  int16 target;  /*The target value, the target point in 0.1mm steps from 0 .. about 3 m . */
  int16 velocity;  /*The increment per cycle step in 0.1 mm as relation to the velocity.*/
  int16 timeStandIdleOnTarget;  /*Time to stand idle on target in steps. */
} SetValueGenerator__Target;
  


/**Default constructor. */
METHOD_C SetValueGenerator__Target* ctor_SetValueGenerator__Target(MemC rawMem, StacktraceThreadContext_s* _threadContext);

typedef struct SetValueGenerator_t
{ ObjectJc object;
  struct LogMessageJc_t* msg;  /*The message interface.*/
  int16 value;  /*The last and next set value. Initial it is the position 1 meter.*/
  int16 dvalue;  /*The increment of value in actual generating*/
  int32 countStandStill;  /*The counter to count the time to stand still. */
  int32 state;  /*State of the movement. Use state variables xxx_State. */
  SetValueGenerator__TargetREF actTarget;  /*The instances for actual and next target point. */
  SetValueGenerator__TargetREF nextTarget;  /*The instances for actual and next target point. */
} SetValueGenerator;
  

  #define kToTarget_State_SetValueGenerator 1  /*State Movement to the target. */
  #define kStandStill_State_SetValueGenerator 2  /*State stand still on target. */
  #define kWaitForNewTarget_State_SetValueGenerator 3  /*State stand still on target. */

/**Constructor needs to know a message interface:*/
METHOD_C SetValueGenerator* ctor_SetValueGenerator(MemC rawMem, struct LogMessageJc_t* msg, StacktraceThreadContext_s* _threadContext);

/**generates the next reference value.*/
METHOD_C short step_SetValueGenerator(SetValueGenerator* ythis, StacktraceThreadContext_s* _threadContext);

/**stores a next target point*/
METHOD_C boolean setTarget_SetValueGenerator(SetValueGenerator* ythis, int16 targetValue, StacktraceThreadContext_s* _threadContext);

/**returns true if the next target is required.*/
METHOD_C boolean requiresNextTarget_SetValueGenerator(SetValueGenerator* ythis, StacktraceThreadContext_s* _threadContext);

#endif //__SetValueGenerator_h__
