#ifndef __WayActuator_h__
#define __WayActuator_h__

#include "ObjectJc.h"
#include "ExceptionJc.h"


typedef struct WayActuator_t
{ /**For real world it may be a hardware i/o-address to access the value from a counter.*/
  int16* hwPort;
}WayActuator;


/**This method is used to set a value for a way to Hardware.
 * @param ythis from Java it is the implementiation class of the WayActuator interface.
 *        But in C it is a struct containing values for hardware access.
 * @param value The value, in the example a milliVolt-Value form -10.0 to 10.0 Volt.
 */
METHOD_C void setMotorVoltage_WayActuator(WayActuator* ythis, int16 value, StacktraceThreadContext_s* _stacktraceThreadContext);

#endif //__WayActuator_h__