package org.vishia.header2Reflection;

import java.io.FileNotFoundException;
import java.text.ParseException;

import org.vishia.mainCmd.MainCmd;
import org.vishia.mainCmd.MainCmd_ifc;
import org.vishia.mainCmd.Report;

public class CmdHeader2Reflection extends MainCmd
{
  
  /**Aggregation to the Console implementation class.*/
  Report console;




  /*---------------------------------------------------------------------------------------------*/
  /** main started from java*/
  public static void main(String [] args)
  { CmdHeader2Reflection mainCmdLine = new CmdHeader2Reflection(args); //the instance to parse arguments and others.
    Header2Reflection main = new Header2Reflection(mainCmdLine);     //the main instance
    boolean bOk = true;
    try{ mainCmdLine.parseArguments(main, args); }
    catch(Exception exception)
    { mainCmdLine.setExitErrorLevel(MainCmd_ifc.exitWithArgumentError);
      bOk = false;
    }
    if(bOk)
    { /** The execution class knows the CmdHeader2Reflection Main class in form of the MainCmd super class
          to hold the contact to the command line execution.
      */
      try{ main.execute(); }
      catch(Exception exception)
      { //catch the last level of error. No error is reported direct on command line!
        main.console.report("Uncatched Exception on main level:", exception);
        exception.printStackTrace(System.err);
        main.console.setExitErrorLevel(MainCmd_ifc.exitWithErrors);
      }
    }
    mainCmdLine.exit();
  }

  
  
  /**The main instance to work, also settled outside calling per cmdLine. */
  Header2Reflection main;

  /**Cmdline-argument, set on -i option. Inputfile to to something. :TODO: its a example.*/
  String sFileIn = null;

  /*---------------------------------------------------------------------------------------------*/
  /** Constructor of the main class.
      The command line arguments are parsed here. After them the execute class is created as composition of CmdHeader2Reflection.
  */
  private CmdHeader2Reflection(String[] args)
  { super(args);
    //:TODO: user, add your help info!
    //super.addHelpInfo(getAboutInfo());
    super.addAboutInfo("Generate Reflection.c and Reflection.h");
    super.addAboutInfo("made by Hartmut Schorrig, 2008-01-06");
    super.addHelpInfo("param: {-i:INPUT} -o:OUTDIR -out.c:OUTFILE -z:CHeader.zbnf -r:FileTypes.txt -ro:FileTypes.out");
    super.addStandardHelpInfo();
    super.addHelpInfo("-i:INPUT    inputfilepath, more as one -i is admissible and typical.");
    super.addHelpInfo("-o:OUTDIT   The Directorypath, where OUTFILE.c and OUTFILE.h were writtenoutputfilepath, this file is written.");
    super.addHelpInfo("TODO...");
  }


  /**The parseArguments is replaced by a variant with reference to the working class, 
   * using the super.parseArguments() indside. 
   */
  public void parseArguments(Header2Reflection main, String [] args)
  throws ParseException
  { this.main = main;
    super.parseArguments(args);
  }  



  /*---------------------------------------------------------------------------------------------*/
  /** Tests one argument. This method is invoked from parseArgument. It is abstract in the superclass MainCmd
      and must be overwritten from the user.
      :TODO: user, test and evaluate the content of the argument string
      or test the number of the argument and evaluate the content in dependence of the number.

      @param argc String of the actual parsed argument from cmd line
      @param nArg number of the argument in order of the command line, the first argument is number 1.
      @return true is okay,
              false if the argument doesn't match. The parseArgument method in MainCmd throws an exception,
              the application should be aborted.
   * @throws FileNotFoundException 
  */
  protected boolean testArgument(String arg, int nArg)
  { boolean bOk = true;  //set to false if the argc is not passed

    if(arg.startsWith("-i:"))      bOk = main.addInputFilemask(getArgument(3));
    else if(arg.startsWith("-o:")) main.setOutDir(getArgument(3));
    else if(arg.startsWith("-z:")) main.setSyntax(getArgument(3));
    else if(arg.startsWith("-r:")) main.setReflectionTypes(getArgument(3));
    else if(arg.startsWith("-b:")) main.setReflectionBlockedTypes(getArgument(3));
    else if(arg.startsWith("-ro:")) main.setReflectionTypesOut(getArgument(4), true);
    else if(arg.startsWith("-ro+")) main.setReflectionTypesOut(getArgument(4), false);
    else if(arg.startsWith("-out.c:")) main.setOutC(getArgument(7));
    else bOk=false;

    return bOk;
  }

  /** Invoked from parseArguments if no argument is given. In the default implementation a help info is written
   * and the application is terminated. The user should overwrite this method if the call without comand line arguments
   * is meaningfully.
   * @throws ParseException 
   *
   */
  protected void callWithoutArguments() throws ParseException
  { //:TODO: overwrite with empty method - if the calling without arguments
    //having equal rights than the calling with arguments - no special action.
    super.callWithoutArguments();  //it needn't be overwritten if it is unnecessary
  }




  /*---------------------------------------------------------------------------------------------*/
  /**Checks the cmdline arguments relation together.
     If there is an inconsistent, a message should be written. It may be also a warning.
     :TODO: the user only should determine the specific checks, this is a sample.
     @return true if successful, false if failed.
  */
  protected boolean checkArguments()
  { return true;
  
  }
 
  
}